package cn.com.qmth.scancloud.tools.config;

import cn.com.qmth.scancloud.tools.enums.TaskType;
import cn.com.qmth.scancloud.tools.service.AbstractTask;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TaskConfig {

    private final static Logger log = LoggerFactory.getLogger(TaskConfig.class);

    public void doTask() {
        log.info("**************************************************");
        log.info("scan.tool.paper-type-barcode={}", SysProperty.PAPER_TYPE_BARCODE);
        log.info("scan.server.url={}", SysProperty.SCAN_SERVER_URL);
        log.info("scan.tool.dataDir={}", SysProperty.DATA_DIR);
        log.info("scan.tool.dataFile={}", SysProperty.DATA_FILE);
        log.info("scan.tool.taskType={}", SysProperty.TASK_TYPE);
        log.info("scan.tool.schoolId={}", SysProperty.SCHOOL_ID);
        log.info("scan.tool.schoolName={}", SysProperty.SCHOOL_NAME);
        log.info("scan.tool.examId={}", SysProperty.EXAM_ID);
        log.info("scan.tool.moreParams={}", SysProperty.MORE_PARAMS);
        log.info("scan.tool.template.separator={}", SysProperty.TEMPLATE_SEPARATOR);
        log.info("scan.tool.template.columns={}", SysProperty.TEMPLATE_COLUMNS);
        log.info("scan.tool.thread.size={}", SysProperty.THREAD_SIZE);
        log.info("**************************************************");

        TaskType taskType = TaskType.findByName(SysProperty.TASK_TYPE);
        if (taskType == null) {
            return;
        }

        AbstractTask task;
        try {
            task = (AbstractTask) taskType.getImpl().newInstance();
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return;
        }
        task.run();
    }

}
