package cn.com.qmth.scancloud.tools.service;

import cn.com.qmth.scancloud.tools.config.SysProperty;
import cn.com.qmth.scancloud.tools.model.Exam;
import cn.com.qmth.scancloud.tools.model.Subject;
import cn.com.qmth.scancloud.tools.utils.HttpHelper;
import cn.com.qmth.scancloud.tools.utils.JsonHelper;

import java.util.HashMap;
import java.util.Map;

public class CommonService {

    public static Exam findExam(Long examId) {
        String url = SysProperty.SCAN_SERVER_URL + "/api/tool/exam/info?examId=" + examId;
        String result = HttpHelper.post(url, null);
        return JsonHelper.toObj(result, Exam.class);
    }

    public static Subject findCourse(Long examId, String subjectCode) {
        Map<String, Object> params = new HashMap<>();
        params.put("examId", examId);
        params.put("subjectCode", subjectCode);

        String url = SysProperty.SCAN_SERVER_URL + "/api/tool/exam/subject/info";
        String result = HttpHelper.post(url, JsonHelper.toJson(params));

        return JsonHelper.toObj(result, Subject.class);
    }

}
