package cn.com.qmth.scancloud.tools;

import ch.qos.logback.classic.Level;
import ch.qos.logback.classic.Logger;
import ch.qos.logback.classic.LoggerContext;
import cn.com.qmth.scancloud.tools.model.ExamStudent;
import cn.com.qmth.scancloud.tools.utils.FileHelper;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.alibaba.excel.write.handler.SheetWriteHandler;
import com.alibaba.excel.write.metadata.holder.WriteSheetHolder;
import com.alibaba.excel.write.metadata.holder.WriteWorkbookHolder;
import org.apache.commons.io.LineIterator;
import org.apache.poi.ss.usermodel.Sheet;
import org.junit.Before;
import org.junit.Test;
import org.slf4j.LoggerFactory;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class DemoTest {

    private final String dataDir = "/home/admin/scan-tool";

    @Test
    public void demo() throws Exception {
        // writeLines();
        // readLines();
        // readAllLines();
        // writeExcel();
        // readExcel();
    }

    private void writeLines() {
        List<String> lines = new ArrayList<>();

        String template = "C00001|课程01|zkzh@|考生@|ksbh@|jdh@|zwh@|学习中心01|考场01|考点01";
        for (int n = 0; n < 100; n++) {
            lines.add(template.replace("@", String.valueOf(n + 1)));
        }

        File file = new File(dataDir + "/data.txt");
        FileHelper.writeLines(file, lines, false);
    }

    private void readLines() {
        File file = new File(dataDir + "/data.txt");

        int total = 0;
        try (LineIterator lines = FileHelper.readLines(file);) {
            while (lines.hasNext()) {
                String line = lines.nextLine();
                // System.out.println(line);
                total++;
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

        System.out.println("total is " + total);
    }

    private void readAllLines() {
        File file = new File(dataDir + "/data.txt");
        List<String> lines = FileHelper.readAllLines(file);

        // for (int n = 0; n < lines.size(); n++) {
        //     System.out.println(lines.get(n));
        // }

        System.out.println("total is " + lines.size());
    }

    private void writeExcel() {
        List<ExamStudent> list = new ArrayList<>();
        for (int n = 0; n < 10; n++) {
            ExamStudent data = new ExamStudent();
            data.setName("考生" + (n + 1));
            list.add(data);
        }

        File file = new File(dataDir + "/data.xlsx");
        EasyExcel.write(file, ExamStudent.class).registerWriteHandler(new SheetWriteHandler() {
            @Override
            public void afterSheetCreate(WriteWorkbookHolder workbookHolder, WriteSheetHolder sheetHolder) {
                Sheet sheet = sheetHolder.getSheet();
                sheet.createFreezePane(1, 1);
            }
        }).sheet().doWrite(list);
    }

    private void readExcel() {
        File file = new File(dataDir + "/data.xlsx");
        EasyExcel.read(file, ExamStudent.class, new AnalysisEventListener<ExamStudent>() {
            List<ExamStudent> list = new ArrayList<>();

            @Override
            public void invoke(ExamStudent data, AnalysisContext context) {
                list.add(data);
            }

            @Override
            public void doAfterAllAnalysed(AnalysisContext context) {
                System.out.println("total is " + list.size());
            }
        }).sheet().doRead();
    }

    @Before
    public void before() {
        // Configurator.setRootLevel(Level.ALL);
        LoggerContext loggerContext = (LoggerContext) LoggerFactory.getILoggerFactory();
        Logger logger = loggerContext.getLogger("cn.com.qmth");
        logger.setLevel(Level.INFO);
    }

}
